# OEM.pm - Character set definitions for Corona, IBM OEM character set.

# Copyright (c)2000, Cat's Eye Technologies.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
#   Redistributions of source code must retain the above copyright
#   notice, this list of conditions and the following disclaimer.
# 
#   Redistributions in binary form must reproduce the above copyright
#   notice, this list of conditions and the following disclaimer in
#   the documentation and/or other materials provided with the
#   distribution.
# 
#   Neither the name of Cat's Eye Technologies nor the names of its
#   contributors may be used to endorse or promote products derived
#   from this software without specific prior written permission. 
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
# CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
# INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
# OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
# OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
# ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE. 

%sc =
(
  'nwbox'  => '',
  'nbox'   => '',
  'nebox'  => '',
  'wbox'   => '',
  'ebox'   => '',
  'swbox'  => '',
  'sbox'   => '',
  'sebox'  => '',

  'person' => chr(1),

  'brick'  => '',
  'hut'    => '',
  'tree'   => chr(5),
  'water'  => '',
  'door'   => '',
  'closed' => chr(143),
  'stair'  => '',
  'floor'  => '',
  'dark'   => ' ',
  'hill'   => '~',
  'mountain'=> '^',
  'marsh'  => chr(171),
  'hole'   => 'o',

  'cloak'  => chr(251),
  'halter' => chr(225),
  'jacket' => chr(203),
  'leggings' => chr(227),
  'helm'   => chr(234),
  'gloves' => chr(174),
  'clothing' => chr(225),
  'boots'  => chr(208),
  'sleeves' => '=',
  'necklace' => chr(160),
  'bracelet' => chr(229),
  'ring' => chr(167),
  'belt' => chr(128),

  'tiny'   => chr(250),
  'rock'   => '*',
  'boulder'=> chr(233),
  'ash'    => ',',
  'crystal'=> '*',

  'food'   => chr(254),
  'fruit'  => chr(248),
  'vegetable' => chr(149),
  'fungus' => ',',
  'root'   => chr(231),
  'grass'  => '"',
  'stalk'  => '"',
  'web'    => '|',

  'gas'    => '@',
  'gate'   => '#',

  'bottle' => '!',
  'coin'   => '$',

  'circle' => '0',

  'sword'  => '/',
  'stick'  => '\\',
  'mace'   => '!',
  'scythe' => '7',
  'arrow'  => '\\',
  'bow'    => ')',
  'crossbow'=> chr(242),

  'scroll' => chr(238),
  'instrument' => chr(245),

  'carcass'=> '@',

  'ursine' => 'B',
  'spider' => 'x',
  'serpent'=> 'S',
  'worm'   => 's',

  'feline' => 'c',
  'primate'=> 'M',
  'bovine' => 'u',
  'porcine'=> 'p',
  'canine' => 'd',

  'dwark'  => 'k',
  'traiple'=> 't',
  'grue'   => 'G',
  'grumchik'=>'g',
  'nymph'  => 'N',
  'dryad'  => 'D',
  'fairy'  => '',

  'skeleton'=>'z',
  'zombie'  =>'z',

  'hag'    => 'h',
  'gator'  => 'y',
  'bird'   => 'v',

  'honeycomb' => chr(232),
  'tunnel'    => chr(249),
  'jelly'     => chr(230),
  'bee'       => 'b',
  'grasshopper' => 'i',

);

1;
